//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <stdio.h>

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "GARCOMMLib_OCX"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::GarCommReceiving(TObject *Sender, long nReceived,
	  long nTotal)
{
	char cwb[128];

	ListBox->Clear();
	wsprintf(cwb, "%d/%d", nReceived, nTotal);
	ListBox->Items->Add(cwb);
	ListBox->Refresh();
	if (nReceived > 100) {
		GarComm->AbortTransfer();
	}
//	::MessageBeep(0xffffffff);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::Button1Click(TObject *Sender)
{
	long ver, id;
	BSTR bstrDescription;

	Screen->Cursor = crHourGlass;
	try {
		ListBox->Clear();
		GarComm->CommPort = 1;		// select COM1
		bstrDescription = GarComm->ReadProductID(&id, &ver);
		if (-1 == id) {
			throw Exception("no response from GPS");
		}
		if (false == bool(GarComm->SetProductID(id))) {
			throw Exception("unsupported GPS");
		}
		ListBox->Items->Add(AnsiString(bstrDescription));
		ListBox->Items->Add(id);
		ListBox->Items->Add(ver);
	}
	catch (Exception& exception) {
		Application->MessageBox(exception.Message.c_str(), "ERROR", MB_ICONSTOP);
	}
	Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::DownloadTrackClick(TObject *Sender)
{
	long ver, id;
	long nTrack, nSegment, nData, nTotal;
	BSTR trackName;

	Screen->Cursor = crHourGlass;
	try {
		ListBox->Clear();
		GarComm->CommPort = 1;		// select COM1
		GarComm->ReadProductID(&id, &ver);
		if (-1 == id) {
			throw Exception("no response from GPS");
		}
		if (false == bool(GarComm->SetProductID(id))) {
			throw Exception("unsupported GPS");
		}
		GarComm->DownloadTrack();
		//
		ListBox->Clear();
		nTrack = GarComm->GetTrackCount();
		nTotal = 0;
		for (long t = 0; t < nTrack; t++) {
			trackName = GarComm->GetTrackName(t);
			ListBox->Items->Add(AnsiString(trackName));
			nSegment = GarComm->GetTrackSegmentCount(t);
			for (long s = 0; s < nSegment; s++) {
				nData = GarComm->GetTrackSegmentDataCount(t, s);
				for (long d = 0; d < nData; d++) {
					double lat, lon, alt;
					char cwb[128];
					GarComm->GetTrackPosition(t, s, d, &lat, &lon, &alt);
					nTotal++;
					sprintf(cwb, "%ld, %f, %f, %f", nTotal, lat, lon, alt);
					ListBox->Items->Add(cwb);
				}
			}
		}
	}
	catch (Exception& exception) {
		Application->MessageBox(exception.Message.c_str(), "ERROR", MB_ICONSTOP);
	}
	Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::Button2Click(TObject *Sender)
{
	long ver, id;

	Screen->Cursor = crHourGlass;
	try {
		ListBox->Clear();
		GarComm->CommPort = 1;		// select COM1
		GarComm->ReadProductID(&id, &ver);
		if (-1 == id) {
			throw Exception("no response from GPS");
		}
		if (false == bool(GarComm->SetProductID(id))) {
			throw Exception("unsupported GPS");
		}
		//
		GarComm->DeleteWaypointAll();
		BSTR id, comment;
		double lat, lon, alt, dst;
		short smbl, dspl;
		// WPT1
		id = WideString("WPT1").Detach();
		comment = WideString("COMMENT1").Detach();
		lat = 35.5;
		lon = 140.25;
		alt = 0;
		smbl = 18;
		dspl = 0;
		GarComm->AddWaypoint(&id, &comment, lat, lon, alt, smbl, dspl, dst);
		// WPT2
		id = WideString("WPT2").Detach();
		comment = WideString("COMMENT2").Detach();
		lat = 35.5;
		lon = 140.25;
		alt = 0;
		smbl = 18;
		dspl = 0;
		GarComm->AddWaypoint(&id, &comment, lat, lon, alt, smbl, dspl, dst);
		// execute upload
		GarComm->UploadWaypoint();
	}
	catch (Exception& exception) {
		Application->MessageBox(exception.Message.c_str(), "ERROR", MB_ICONSTOP);
	}
	Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------

